/*
    SpellTime for Java: Demo program
     
    This simple extension of the java.awt.Frame class
    contains all the elements necessary to act as the
    main window of an application.
 */

import java.applet.*;
import java.awt.*;
import java.io.*;

import stj.*;

public class demo extends Frame implements FilenameFilter{
   //{{DECLARE_CONTROLS
   java.awt.FileDialog openFileDialog1;
   java.awt.Label label1;
   java.awt.TextArea TextArea1;
   java.awt.Button SpellCheck;
   java.awt.TextArea ResultArea;
   java.awt.Label label2;
   //symantec.itools.db.awt.Checkbox checkbox1;
   //}}

   //{{DECLARE_MENUS
   java.awt.MenuBar mainMenuBar;
   java.awt.Menu menu1;
   //}}
 
   // Variable declaractions
   SpellTime stj;      // SpellTime object
   boolean interactive=true;  // true for interactive session
  
  /*********************************************************************
   This function does the following:
     1. Retrieve the text from the text area.
     2. parse the parse to get individual words.
     3. Calls the spellchecker to check the word
     4. Show the misspelled words in the ResultArea text box.
  **********************************************************************/
  void SpellCheck_Clicked(Event event) {
     String text = TextArea1.getText();
     int WordCount=0,ErrorCount=0;

		
     ResultArea.setText("");   // clear the result area
	
     StString CurWord=new StString("");        // Use StString class variable instead of simple String variable to pass by reference
     StInteger WordIndex = new StInteger(0);   // index of the extraced word in the buffer
     StInteger CurIndex = new StInteger(0);    // indicates next character to parse
     StInteger ResultCode=new StInteger(0);

     while (stj.StParseLine(text,CurWord,WordIndex,CurIndex,text.length())>0) {
        WordCount++;                             // number of words checked
      
        // do a quick search first
        boolean result=stj.SpellWord(CurWord.getValue(),0,ResultCode);  // quick search
	  
        // if word not found, then search for alternate words
        if (!result) {
            ErrorCount++;                         // number of misspelled words
         
            if (interactive) {  // do interactive session
              result=stj.SpellWord(CurWord.getValue(),stj.ST_INTERACTIVE,ResultCode);
             
              int code=ResultCode.getValue();

              // replace the word
              String ReplaceWith=stj.StGetReplacement();
              if (ReplaceWith.length()!=0) {   // a replacement word specified
                 int PrevLineLen=text.length();
                 int PrevWordLen=CurWord.getValue().length();
                 int CurWordIndex=WordIndex.getValue();
                 int NextWordIndex=CurIndex.getValue();
                 text=text.substring(0,CurWordIndex)+ReplaceWith+text.substring(NextWordIndex);

                 NextWordIndex+=(ReplaceWith.length()-PrevWordLen);  // update the next word index
                 CurIndex.setValue(NextWordIndex);         // this is where the next word is found
              }     

              if ((code&stj.ST_EXIT)!=0) break;
            }
            else {      // simply show the alterate words in the text box
              int AlternateCount=stj.StGetAlternateWordCount();
              ResultArea.appendText(CurWord.getValue());
              ResultArea.appendText(": ");
	        
              for (int i=0;i<AlternateCount;i++) {
                if (i>0) ResultArea.appendText(",");
                String AlternateWord=stj.StGetAlternateWord(i);
                ResultArea.appendText(AlternateWord);
              }
              ResultArea.appendText("\n");  // terminate the line
            }
        }  
     }
     stj.StResetUserDict(null,null);   // save any changes to the user dictionary

     ResultArea.appendText(text); // add the modified line
     ResultArea.appendText("\n-------------------\n");

     // print the statistics
     ResultArea.appendText("Number of Words checked: ");
     ResultArea.appendText(Integer.toString(WordCount));
     ResultArea.appendText("  Number of Misspelled Words: ");
     ResultArea.appendText(Integer.toString(ErrorCount));
  }
  

  void Open_Action(Event event) {
     // Action from Open... Show the OpenFileDialog
     openFileDialog1.setFile("test.txt");
     openFileDialog1.setFilenameFilter(this);
     openFileDialog1.show();
	
     // Read the file into the input text area
     byte[] buf ={0};
     try {
       FileInputStream iStream = new FileInputStream(openFileDialog1.getFile());
       buf= new byte[iStream.available()];
	
       iStream.read(buf);
       iStream.close();
     } catch(FileNotFoundException e) {
       System.err.println("File Not Found");
     } catch(IOException e) {
       e.printStackTrace();
     }
	
     TextArea1.setText("");
     TextArea1.insertText(new String(buf,0),0);
  }
  
  public boolean accept(File dir, String name) { // implement the file name filter interface
     return name.endsWith(".txt"); 
  }


  void Exit_Action(Event event) {
     // assign text to text area
     TextArea1.insertText("This is inserted text",0);
  }

  public demo() {
     setLayout(null);
     addNotify();
     resize(insets().left + insets().right + 549,insets().top + insets().bottom + 404);
     openFileDialog1 = new java.awt.FileDialog(this, "Open",FileDialog.LOAD);
    
     label1 = new java.awt.Label("Type some text here, then click on the 'Spell Check' button");
     label1.reshape(insets().left + 12,insets().top + 12,312,12);
     add(label1);
     TextArea1 = new java.awt.TextArea();
     TextArea1.reshape(insets().left + 12,insets().top + 36,528,156);
     add(TextArea1);
     SpellCheck = new java.awt.Button("SpellCheck");
     SpellCheck.reshape(insets().left + 332,insets().top + 12,91,17);
     add(SpellCheck);
     ResultArea = new java.awt.TextArea();
     ResultArea.reshape(insets().left + 12,insets().top + 228,528,144);
     add(ResultArea);
     label2 = new java.awt.Label("Spell Check Result");
     label2.reshape(insets().left + 12,insets().top + 204,132,15);
     add(label2);
     setTitle("Spell Time Demo");

     //{{INIT_MENUS
     mainMenuBar = new java.awt.MenuBar();

     menu1 = new java.awt.Menu("File");
     menu1.add("Open...");
     menu1.addSeparator();
     menu1.add("Exit");
     mainMenuBar.add(menu1);
     setMenuBar(mainMenuBar);

     // Create the spell time object
     stj = new SpellTime();                                                   
      
     stj.StSetParentFrame(this);   // set the parent for SpellTime interactive dialog
  }

  public demo(String title) {
     this();
     setTitle(title);
  }

  public synchronized void show() {
     move(50, 50);
     super.show();
  }

  public boolean handleEvent(Event event) {
      if (event.id == Event.WINDOW_DESTROY) {
             hide();         // hide the Frame
             dispose();      // free the system resources
             System.exit(0); // close the application
             return true;
      }
      if (event.target == SpellCheck && event.id == Event.ACTION_EVENT) {
         SpellCheck_Clicked(event);
         return true;
      }
      return super.handleEvent(event);
  }

  public boolean action(Event event, Object arg) {
     if (event.target instanceof MenuItem) {
        String label = (String) arg;
        if (label.equalsIgnoreCase("Open...")) {
           Open_Action(event);
           return true;
        } else if (label.equalsIgnoreCase("Exit")) {
          Exit_Action(event);
          return true;
        }
     }
     return super.action(event, arg);
  }

  static public void main(String args[]) {
      (new demo()).show();
  }

}
